码迷,mamicode.com
首页 > 其他好文 > 详细

【原创】leetCodeOj --- Jump Game II 解题报告

时间:2014-12-09 19:10:31      阅读:159      评论:0      收藏:0      [点我收藏+]

标签:style   blog   http   io   ar   color   os   sp   for   

原题地址:

https://oj.leetcode.com/problems/jump-game-ii/

 

题目内容:

Given an array of non-negative integers, you are initially positioned at the first index of the array.

Each element in the array represents your maximum jump length at that position.

Your goal is to reach the last index in the minimum number of jumps.

For example:
Given array A = [2,3,1,1,4]

The minimum number of jumps to reach the last index is 2. (Jump 1 step from index 0 to 1, then 3 steps to the last index.)

 

方法:

这里比较微妙,尽管用dp硬解和用贪心的复杂度都是O(n^2),但贪心有常数上的优势,也的确ac了。用dp硬解则是TLE。

首先初始化终点fin为n - 1,然后从头开始,找到第一个能到达终点的点,并把终点更新为该点,同时步数加1。因为该点离终点只有一步之遥,所以经过该点到终点步数最短。

重复直到fin为0

 

全部代码:

class Solution {
public:
    int jump(int A[], int n) {
        if (n == 1)
            return 0;
        int fin  = n - 1;
        int step = 0;
        while (fin != 0)
        {
            for (int i = 0;i < fin;i++)
            {
                if (A[i] >= fin - i)
                {
                    fin = i;
                    step ++;
                    break;
                }
            }
        }
        return step;
    }
};

 

【原创】leetCodeOj --- Jump Game II 解题报告

标签:style   blog   http   io   ar   color   os   sp   for   

原文地址:http://www.cnblogs.com/shadowmydx/p/4153754.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!